#include "md5.h"

#include <stdio.h>
#include <string.h>

void
do_check (void)
{
  unsigned char dm3[16], dm2[16], dm1[16], d0[16];
  unsigned char data[64], digest[16];
  struct md5_ctx context;
  int i, j;

  memset (dm3, 0, 16);
  memset (dm2, 0, 16);
  memset (dm1, 0, 16);
  memset (d0, 0, 16);
  for ( i=0 ; i<64 ; i++ )
    {
      memcpy (data, d0, 16);
      memcpy (data+16, dm1, 16);
      memcpy (data+32, dm2, 16);
      memcpy (data+48, dm3, 16);
      MD5_start (&context);
      for ( j=0 ; j<i ; j++ )
	MD5_feed (&context, data[j]);
      MD5_stop (&context, digest);
      printf ("I=%d\n", i);
      printf ("DATA=");
      for ( j=0 ; j<i ; j++ )
	printf ("%02X", data[j]);
      printf ("\n");
      printf ("DIGEST=");
      for ( j=0 ; j<16 ; j++ )
	printf ("%02X", digest[j]);
      printf ("\n");
      printf ("\n");
      memcpy (dm3, dm2, 16);
      memcpy (dm2, dm1, 16);
      memcpy (dm1, d0, 16);
      memcpy (d0, digest, 16);
    }
}

int
main (void)
{
  do_check ();
  return 0;
}
