#include "sha1.h"

#include <stdio.h>
#include <string.h>

void
do_check (void)
{
  unsigned char dm3[20], dm2[20], dm1[20], d0[20];
  unsigned char data[80], digest[20];
  struct sha1_ctx context;
  int i, j;

  memset (dm3, 0, 20);
  memset (dm2, 0, 20);
  memset (dm1, 0, 20);
  memset (d0, 0, 20);
  for ( i=0 ; i<80 ; i++ )
    {
      memcpy (data, d0, 20);
      memcpy (data+20, dm1, 20);
      memcpy (data+40, dm2, 20);
      memcpy (data+60, dm3, 20);
      SHA1_start (&context);
      for ( j=0 ; j<i ; j++ )
	SHA1_feed (&context, data[j]);
      SHA1_stop (&context, digest);
      printf ("I=%d\n", i);
      printf ("DATA=");
      for ( j=0 ; j<i ; j++ )
	printf ("%02X", data[j]);
      printf ("\n");
      printf ("DIGEST=");
      for ( j=0 ; j<20 ; j++ )
	printf ("%02X", digest[j]);
      printf ("\n");
      printf ("\n");
      memcpy (dm3, dm2, 20);
      memcpy (dm2, dm1, 20);
      memcpy (dm1, d0, 20);
      memcpy (d0, digest, 20);
    }
}

int
main (void)
{
  do_check ();
  return 0;
}
